{% extends "calib/template.html" %}
{% block title %} Calibration {% endblock %}
{% block heading %} Calibration - step 4 {% endblock %}
{% block content %}
	<h3> Select the inner 8x8 array of transducers </h3>
	<p> Remove any obstructions from the manipulation area, so that the camera has a clear view of the transducer array. Mark the four corner transducers of the inner 8x8 array by clicking on the image below. Clicking on an empty space creates a corner point. You can modify existing corner points by dragging and dropping. </p>
	<div id="debug"></div>

	<div class="imgbox">
		<svg id="svg" style="width:50%;height:50%" viewBox="0 0 480 480" xmlns="http://www.w3.org/2000/svg">
			<image href="http://{{my_ip}}:5001/image/Balls/image" x="0" y="0" id="img" height="480" width="480" />
			{% for i in range(4) %}
			<g class="corner" id="corner{{i}}" data-index="{{i}}" data-visible="false" visibility="hidden" transform="translate({{20*i}},0)">
				<circle cx="0" cy="0" r="10" style="fill:red;fill-opacity:0.5"></circle>
			</g>
			{% endfor %}
		</svg>
	</div>

	<div class="float-right">
		<a class="btn btn-success disabled" id="continue" href="/calib/4/0" role="button">Continue</a>
	</div>
	<div class="float-left">
		<a class="btn btn-danger" href="/calib/2" role="button">Back</a>
	</div>
	<div style="text-align: center">
		<button class="btn btn-primary" align="middle" onclick="location.reload()" id="refresh" role="button">Refresh (warning: cancels current progress)</button>
	</div>	
{% endblock %}
{% block scripts %} 
{{ super() }}
<script type="text/javascript">
	var pt = $("svg")[0].createSVGPoint();  // Created once for document
	var selected_corner = null;
	var corner_count = 0;

	function select_corner(ev) {
		selected_corner = $(this);
	}

	function deselect_corner(ev) {
		selected_corner = null;
	}	

	function move(x, y) {
		if (selected_corner != null) {
			pt.x = x;
			pt.y = y;

			// The cursor point, translated into svg coordinates
			var cursorpt = pt.matrixTransform($("#img")[0].getScreenCTM().inverse());
			x = cursorpt.x;
			y = cursorpt.y;

			index = selected_corner.data('index');
			visible = selected_corner.data('visible');

			if (visible) {
				pos = [x,y];
				selected_corner.trigger("move", pos);
				socket.emit("corner", index, pos);
			}
		}
	}

	function img_click(x, y) {
		if (selected_corner == null && corner_count < 4) {
			pt.x = x;
			pt.y = y;

			// The cursor point, translated into svg coordinates
			var cursorpt = pt.matrixTransform($("#img")[0].getScreenCTM().inverse());
			x = cursorpt.x;
			y = cursorpt.y;
			pos = [x,y];

			new_corner = $("#corner" + corner_count)[0];
			new_corner.setAttribute("transform", "translate(" + x + "," + y + ")")
			new_corner.setAttribute("visibility", "visible")
			new_corner.setAttribute("data-visible", "true")
			socket.emit("corner", corner_count, pos);
			corner_count += 1;
			if (corner_count > 3) {
				$(".btn-success").removeClass("disabled")
			}
		}
	}

	$(function () {
		$(".corner").on("move", function (evt, x, y) {
			$(this).attr("transform", "translate(" + x + "," + y + ")")
		})

		$(".corner").on('touchstart', select_corner)
		$(".corner").mousedown(select_corner);
		$("svg").mouseup(deselect_corner)
		$("svg").on('touchend', deselect_corner)
		$("svg").on('mousemove', function (event) {
			_this = $(this)
			event.preventDefault();
			var e = event.originalEvent;
			move(event.clientX, event.clientY);
			if (selected_corner != null) console.log('Mouse move')
		})
		$("svg").bind("touchmove", function (event) {
			_this = $(this)
			event.preventDefault();
			x = event.originalEvent.targetTouches[0].clientX;
			y = event.originalEvent.targetTouches[0].clientY;
			move(x, y);
			if (selected_corner != null) console.log('Touch move')
		});
		$("svg").mousedown(function (event) {
			_this = $(this)
			event.preventDefault();
			var e = event.originalEvent;
			img_click(event.clientX, event.clientY);
		})
		$("svg").on("touchstart", function (event) {
			_this = $(this)
			event.preventDefault();
			x = event.originalEvent.targetTouches[0].clientX;
			y = event.originalEvent.targetTouches[0].clientY;
			img_click(x, y);
		});
	})

	var socket = io.connect('http://' + document.domain + ':' + location.port);
</script>
{% endblock %}